/*
 * Author: Radovan Cerveny
 */

#ifndef EXACT_FACTOR_ORACLE_AUTOMATON_H_
#define EXACT_FACTOR_ORACLE_AUTOMATON_H_

#include <automaton/FSM/DFA.h>
#include <string/LinearString.h>

namespace stringology {

namespace indexing {

class ExactFactorOracleAutomaton {
private:
	static void oracleAddLetter ( automaton::DFA < > & oracle, const DefaultSymbolType & symbol, ext::map < DefaultStateType, DefaultStateType > & supplyFunction );

public:
	/**
	 * Constructs factor oracle automaton for given pattern.
	 * @return factor oracle automaton for given pattern
	 */
	static automaton::DFA < > construct ( const string::LinearString < > & pattern );

};

} /* namespace indexing */

} /* namespace stringology */

#endif /* EXACT_FACTOR_ORACLE_AUTOMATON_H_ */
