/*
 * HopcroftTarjan.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_HOPCROFT_TARJAN_H_
#define GRAPH_HOPCROFT_TARJAN_H_

#include <core/multipleDispatch.hpp>

#include <graph/GraphClasses.h>

namespace graph
{

namespace embedding
{

// Computes combinatorial embedding of bidirected biconnected simple planar graph
class HopcroftTarjan : public alib::SingleDispatch<HopcroftTarjan, ext::unordered_map<Node, ext::vector<Node>>, const graph::GraphBase &>
{
public:
	typedef ext::unordered_map<Node, ext::vector<Node>> Result;

	static Result hopcrofttarjan(const Graph &graph);

	static Result hopcrofttarjan(const DirectedGraph &graph);
	static Result hopcrofttarjan(const UndirectedGraph &graph);
};

} // namespace embedding

} // namespace graph

#endif // GRAPH_HOPCROFT_TARJAN_H_
