/*
 * AutomatonAccess.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef AUTOMATA_ACCESS_H_
#define AUTOMATA_ACCESS_H_

#include <core/multipleDispatch.hpp>

#include "automaton/Automaton.h"
#include "automaton/AutomatonFeatures.h"

#include "settings/AutomatonSettings.h"
#include "settings/OperationSettings.h"
#include <set>

namespace dataAccess {

class AutomatonAccess : public alib::SingleDispatch < AutomatonAccess, void, automaton::AutomatonBase &, const AutomatonSettings::Settings &, const OperationSettings::Settings &, ext::deque < sax::Token > & > {
public:
	static void access ( automaton::Automaton & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );

	static void access ( automaton::NFA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( automaton::DFA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );

	static void access ( automaton::InputDrivenNPDA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( automaton::InputDrivenDPDA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );

	static void access ( automaton::DPDA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( automaton::NPDA < > & automaton, const AutomatonSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
};

} /* namespace dataAccess */

#endif /* AUTOMATA_ACCESS_H_ */
