#ifndef _CAST_PARAM_H_
#define _CAST_PARAM_H_

#include <ast/Param.h>
#include <abstraction/common/CastHelper.h>

namespace cli {

class CastParam final : public Param {
	std::unique_ptr < cli::Arg > m_type;
	std::unique_ptr < Param > m_param;

public:
	CastParam ( std::unique_ptr < cli::Arg > type, std::unique_ptr < Param > param ) : Param ( true ), m_type ( std::move ( type ) ), m_param ( std::move ( param ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		std::string type = m_type->eval ( environment );

		std::shared_ptr < abstraction::OperationAbstraction > translatedParam = m_param->translateAndEval ( prev, environment );

		return abstraction::CastHelper::eval ( translatedParam, type, getMove ( ) );
	}
};

} /* namespace cli */

#endif /* _CAST_PARAM_H_ */
