#ifndef _CLI_FILE_PARAM_H_
#define _CLI_FILE_PARAM_H_

#include <ast/Param.h>

#include <abstraction/common/XmlParserHelper.h>

namespace cli {

class FileParam final : public Param {
	std::unique_ptr < cli::Arg > m_arg;

public:
	FileParam ( std::unique_ptr < cli::Arg > arg ) : Param ( true ), m_arg ( std::move ( arg ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		std::string file = m_arg->eval ( environment );

		return abstraction::XmlParserHelper::eval ( "", file );
	}
};

} /* namespace cli */

#endif /* _CLI_FILE_PARAM_H_ */
