#include <ast/statements/FileStatement.h>
#include <ast/Statement.h>
#include <ast/Option.h>
#include <ast/Arg.h>

#include <abstraction/common/XmlParserHelper.h>

namespace cli {

FileStatement::FileStatement ( std::unique_ptr < TypeOption > type, std::unique_ptr < Arg > file ) : m_file ( std::move ( file ) ), m_type ( std::move ( type ) ) {
}

std::shared_ptr < abstraction::OperationAbstraction > FileStatement::translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const {
	std::string type = "";
	if ( m_type )
		type = m_type->getType ( );

	std::string file = m_file->eval ( environment );

	return abstraction::XmlParserHelper::eval ( std::move ( type ), file );
}

} /* namespace cli */
