/*
 * NormalizeRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/NormalizeRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > NormalizeRegistry::getAbstraction ( const std::string & param ) {
	auto res = getEntries ( ).find ( param );
	if ( res == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + param + " not available." );

	return res->second->getAbstraction ( );
}

bool NormalizeRegistry::hasNormalize ( const std::string & param ) {
	auto res = getEntries ( ).find ( param );
	return res != getEntries ( ).end ( );
}

} /* namespace abstraction */
