/*
 * GlobalData.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _GLOBAL_DATA_H_
#define _GLOBAL_DATA_H_

#include <functional>
#include <istream>
#include <ostream>

namespace common {

class GlobalData {
public:
	static bool verbose;
	static bool measure;
	static bool optimizeXml;

	static int argc;
	static char * * argv;
};

class Streams {
public:
	static ext::reference_wrapper < std::istream > in;
	static ext::reference_wrapper < std::ostream > out;
	static ext::reference_wrapper < std::ostream > err;
	static ext::reference_wrapper < std::ostream > log;
	static ext::reference_wrapper < std::ostream > measure;
};

} /* common */

namespace ext {

template < class T >
std::ostream & operator << ( ext::reference_wrapper < std::ostream > & os, T & data ) {
	os.get ( ) << data;
	return os;
}

template < class T >
std::ostream & operator << ( ext::reference_wrapper < std::ostream > & os, T && data ) {
	os.get ( ) << data;
	return os;
}

std::ostream & operator << ( ext::reference_wrapper < std::ostream > & os, std::ostream & ( * func ) ( std::ostream & ) );

std::ostream & operator << ( ext::reference_wrapper < std::ostream > & os, std::ios_base & ( * func ) ( std::ios_base & ) );



template < class T >
std::istream & operator >> ( ext::reference_wrapper < std::istream > & is, T & data ) {
	is.get ( ) >> data;
	return is;
}

std::istream & operator >> ( ext::reference_wrapper < std::istream > & is, std::ios_base & ( * func ) ( std::ios_base & ) );

} /* namespace ext */

#endif /* _GLOBAL_DATA_H_ */
