/*
 * SubtreeWildcardSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "SubtreeWildcardSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

SubtreeWildcardSymbol::SubtreeWildcardSymbol() {

}

SymbolBase* SubtreeWildcardSymbol::clone() const {
	return new SubtreeWildcardSymbol(*this);
}

SymbolBase* SubtreeWildcardSymbol::plunder() && {
	return new SubtreeWildcardSymbol(std::move(*this));
}

int SubtreeWildcardSymbol::compare(const SubtreeWildcardSymbol&) const {
	return 0;
}

void SubtreeWildcardSymbol::operator>>(std::ostream& out) const {
	out << "(SubtreeWildcardSymbol)";
}

SubtreeWildcardSymbol::operator std::string () const {
	return SubtreeWildcardSymbol::instance < std::string > ( );
}

SymbolBase* SubtreeWildcardSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::SubtreeWildcardSymbol > ( );

} /* namespace */
