/*
 * MultiInitialStateNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "MultiInitialStateNFA.h"
#include <automaton/Automaton.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < automaton::MultiInitialStateNFA < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < automaton::Automaton, automaton::MultiInitialStateNFA < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < alib::Object, automaton::MultiInitialStateNFA < > > ( );

static auto xmlReader = registration::XmlReaderRegister < automaton::Automaton, automaton::MultiInitialStateNFA < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < alib::Object, automaton::MultiInitialStateNFA < > > ( );

static auto multiInitialStateNFAFromDFA = registration::CastRegister < automaton::MultiInitialStateNFA < >, automaton::DFA < > > ( );
static auto multiInitialStateNFAFromNFA = registration::CastRegister < automaton::MultiInitialStateNFA < >, automaton::NFA < > > ( );

} /* namespace */
