/*
 * PostfixRankedTree.cpp
 *
 *  Created on: May 4, 2017
 *      Author: Aleksandr Shatrovskii
 */

#include "PostfixRankedTree.h"
#include <tree/Tree.h>
#include <tree/RankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < tree::PostfixRankedTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PostfixRankedTree < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::PostfixRankedTree < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PostfixRankedTree < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PostfixRankedTree < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::PostfixRankedTree < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PostfixRankedTree < > > ( );

static auto PostfixRankedTreeFromRankedTree = registration::CastRegister < tree::PostfixRankedTree < >, tree::RankedTree < > > ( );

} /* namespace */
