/*
 * PrefixRankedBarTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedBarTree.h"
#include <tree/Tree.h>
#include <tree/RankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < tree::PrefixRankedBarTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PrefixRankedBarTree < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::RankedTreeWrapper, tree::PrefixRankedBarTree < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PrefixRankedBarTree < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PrefixRankedBarTree < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::RankedTreeWrapper, tree::PrefixRankedBarTree < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PrefixRankedBarTree < > > ( );

static auto PrefixRankedBarTreeFromRankedTree = registration::CastRegister < tree::PrefixRankedBarTree < >, tree::RankedTree < > > ( );

} /* namespace */
