/*
 * PrefixBarTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixBarTree.h"
#include <tree/Tree.h>
#include <tree/UnrankedTreeWrapper.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < tree::PrefixBarTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::Tree, tree::PrefixBarTree < > > ( );
static auto xmlWrite2 = registration::XmlWriterRegister < tree::UnrankedTreeWrapper, tree::PrefixBarTree < > > ( );
static auto xmlWrite3 = registration::XmlWriterRegister < alib::Object, tree::PrefixBarTree < > > ( );

static auto xmlReader = registration::XmlReaderRegister < tree::Tree, tree::PrefixBarTree < > > ( );
static auto xmlReaded2 = registration::XmlReaderRegister < tree::UnrankedTreeWrapper, tree::PrefixBarTree < > > ( );
static auto xmlReaded3 = registration::XmlReaderRegister < alib::Object, tree::PrefixBarTree < > > ( );

static auto PrefixBarTreeFromUnrankedTree = registration::CastRegister < tree::PrefixBarTree < >, tree::UnrankedTree < > > ( );

} /* namespace */
