#ifndef PATTERN_TEST_H_
#define PATTERN_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class PatternTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( PatternTest );
  CPPUNIT_TEST( testRankedPatternParser );
  CPPUNIT_TEST( testUnrankedPatternParser );
  CPPUNIT_TEST( testPrefixRankedPatternParser );
  CPPUNIT_TEST( testPrefixRankedBarPatternParser );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testRankedPatternParser();
  void testUnrankedPatternParser();

  void testPrefixRankedPatternParser();
  void testPrefixRankedBarPatternParser();
};

#endif  // PATTERN_TEST_H_
