/*
 * RawReaderAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _RAW_READER_ABSTRACTION_HPP_
#define _RAW_READER_ABSTRACTION_HPP_

#include <abstraction/BinaryOperationAbstraction.hpp>
#include <factory/RawDataFactory.hpp>

namespace abstraction {

template < class ReturnType >
class RawReaderAbstraction : public BinaryOperationAbstraction < ReturnType, const std::string &, std::string && > {
public:
	virtual bool run ( ) override {
		if ( this->isReady ( ) )
			return true;

		ReturnType res = alib::RawDataFactory::fromString ( std::get < 1 > ( this->m_params )->getRValueReference ( ) );
		this->m_data = std::move ( res );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _RAW_READER_ABSTRACTION_HPP_ */
