/*
 * UniqueSymbol.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "UniqueSymbol.h"
#include <alphabet/UniqueSymbol.h>
#include <object/Object.h>
#include <alphabet/Symbol.h>
#include <primitive/string/Integer.h>

#include <registration/StringRegistration.hpp>

namespace alib {

alphabet::UniqueSymbol stringApi < alphabet::UniqueSymbol >::parse ( std::istream & ) {
	throw exception::CommonException("parsing UniqueSymbol from string not implemented");
}

bool stringApi < alphabet::UniqueSymbol >::first ( std::istream & ) {
	return false;
}

void stringApi < alphabet::UniqueSymbol >::compose ( std::ostream & output, const alphabet::UniqueSymbol & symbol ) {
	output << '<';
	stringApi < alphabet::Symbol >::compose ( output, symbol.getSymbol ( ) );
	output << ", ";
	stringApi < primitive::Integer >::compose ( output, symbol.getId ( ) );
	output << '>';
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < alphabet::Symbol, alphabet::UniqueSymbol > ( );
static auto stringWrite2 = registration::StringWriterRegister < alib::Object, alphabet::UniqueSymbol > ( );

} /* namespace */
