/*
 * Void.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "Void.h"
#include <primitive/Primitive.h>
#include <object/Object.h>

#include <registration/StringRegistration.hpp>

namespace alib {

alib::Void stringApi < alib::Void >::parse ( std::istream & ) {
	throw exception::CommonException("parsing Void from string not implemented");
}

bool stringApi < alib::Void >::first ( std::istream & ) {
	return false;
}

void stringApi < alib::Void >::compose ( std::ostream & output, const alib::Void & ) {
	output << "Void";
}

} /* namespace alib */

namespace {

static auto stringWrite = registration::StringWriterRegister < alib::Object, alib::Void > ( );

} /* namespace */
