/*
 * XmlTokensParserAbstraction.hpp
 *
 *  Created on: 7. 10. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_TOKENS_PARSER_ABSTRACTION_HPP_
#define _XML_TOKENS_PARSER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>

namespace abstraction {

class XmlTokensParserAbstraction : public UnaryOperationAbstraction < ext::deque < sax::Token >, const std::string & > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		ext::deque < sax::Token > tokens;
		sax::SaxParseInterface::parseFile ( std::get < 0 > ( this->m_params )->getConstValueReference ( ), tokens );
		this->m_data = tokens;
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_TOKENS_PARSER_ABSTRACTION_HPP_ */
