/*
 * XmlComposerHelper.cpp
 *
 *  Created on: 25. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/common/XmlComposerHelper.h>

#include <abstraction/XmlRegistry.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > XmlComposerHelper::eval ( std::shared_ptr < abstraction::OperationAbstraction > param, const std::string & file ) {
	std::shared_ptr < abstraction::OperationAbstraction > tokens = abstraction::XmlRegistry::getXmlComposerAbstraction ( param->getReturnType ( ) );
	if ( ! tokens->attachInput ( param, 0, false ) )
		throw exception::CommonException ( "Can't connect param at 0 of result file statement with result of type " + param->getReturnType ( ) + "." );
	if ( ! tokens->eval ( ) )
		throw exception::CommonException ( "Eval of result file statement failed." );

	std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::XmlRegistry::tokensToFileAbstraction ( file );
	res->attachInput ( tokens, 0, true );
	res->eval ( );

	return res;
}


} /* namespace abstraction */
