/*
 * UniqueObject.cpp
 *
 *  Created on: Nov 11, 2016
 *      Author: Jan Travicek
 */

#include "UniqueObject.h"
#include <primitive/xml/Integer.h>

#include <registration/XmlRegistration.hpp>

namespace alib {

alib::UniqueObject xmlApi < alib::UniqueObject >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );

	Object firstSymbol = alib::xmlApi < Object >::parse ( input );
	primitive::Integer secondSymbol = alib::xmlApi < primitive::Integer >::parse ( input );

	UniqueObject data ( std::move ( firstSymbol ), std::move ( secondSymbol ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < alib::UniqueObject >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alib::UniqueObject >::xmlTagName ( ) {
	static std::string xmlTagName = "UniqueObject";

	return xmlTagName;
}

void xmlApi < alib::UniqueObject >::compose ( ext::deque < sax::Token > & output, const alib::UniqueObject & object ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	alib::xmlApi < alib::Object >::compose ( output, object.getSymbol ( ) );
	alib::xmlApi < primitive::Integer >::compose ( output, object.getId ( ) );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace alib */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alib::Object, alib::UniqueObject > ( );

static auto xmlReaded = registration::XmlReaderRegister < alib::Object, alib::UniqueObject > ( );

} /* namespace */
