/*
 * Void.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Void.h"
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace alib {

void xmlApi < void >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
}

bool xmlApi < void >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < void >::xmlTagName ( ) {
	static std::string xmlTagName = "Void";

	return xmlTagName;
}

void xmlApi < void >::compose ( ext::deque < sax::Token > & output ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

alib::Void xmlApi < alib::Void >::parse ( ext::deque < sax::Token >::iterator & input ) {
	xmlApi < void >::parse ( input );
	return alib::Void ( );
}

bool xmlApi < alib::Void >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alib::Void >::xmlTagName ( ) {
	return xmlApi < void >::xmlTagName ( );
}

void xmlApi < alib::Void >::compose ( ext::deque < sax::Token > & output, const alib::Void & ) {
	xmlApi < void >::compose ( output );
}

} /* namespace alib */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alib::Object, alib::Void > ( );

static auto xmlReaded = registration::XmlReaderRegister < alib::Object, alib::Void > ( );

} /* namespace */
