/*
 * StringLabel.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_PRIMITIVE_STRING_H_
#define _XML_PRIMITIVE_STRING_H_

#include <primitive/String.h>
#include <core/xmlApi.hpp>

namespace alib {

template < >
struct xmlApi < std::string > {
	static std::string parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const std::string & data );
};

template < >
struct xmlApi < primitive::String > {
	static primitive::String parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const primitive::String & data );
};

} /* namespace alib */

#endif /* _XML_PRIMITIVE_STRING_H_ */
